#ifndef DYNAMICBOXOBJECT_H
#define DYNAMICBOXOBJECT_H

#include <string>

#include <ode/ode.h>
#include <plib/ssg.h>

#include "dynamicobject.h"


class DynamicBoxObject : public DynamicObject
{
  public:
    DynamicBoxObject(ssgEntity *model, dWorldID world, dSpaceID bigspace, sgVec3 pos, sgVec3 scl) :
    DynamicObject(model, world, bigspace)
    {
      body = dBodyCreate (world);
      dBodySetPosition (body,pos[0],pos[1],pos[2]);
      dMass m;
      dMassSetBox (&m,1,scl[0],scl[1],scl[2]);
      dBodySetMass (body,&m);
      geom = dCreateBox (bigspace,scl[0],scl[1],scl[2]);
      dGeomSetBody (geom,body);
      dGeomSetData (geom,this);
    }
    virtual ~DynamicBoxObject()
    { 
      dGeomDestroy(geom);
    }
};

#endif
